#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <mbstring.h>
#include <time.h>
#include <io.h>
#include "cgi.h"
#include "isock.h"
#include "gMail.h"

const MAX_MSGBODY_SIZE = 15360;
const MAX_EMAIL_HEADER_SIZE = 500;
const char VERSION[] = "1.62";
const TYPE_INT = 1;
const TYPE_CHAR = 2;
const TYPE_EMAIL = 3;

int FORM_ERRORS = FALSE;

CTemplateInfo::CTemplateInfo()
{
	cgiData.Initialize("POST");
	m_pFormInformation = new FormContents;

	m_pDataFile = m_pTemplateName = m_pSendTo = m_pRawData =
	   m_pMailMsgBody = m_pMsgBody = m_pSucceed = m_pSubject = m_pRSubject = 
	   m_pMailFrom = m_pRespondMsg = m_pRawFormData = m_pErrTemplate = m_pSMTPServer = 
	   m_pDefaultSender = m_pDataFile = NULL;
	m_DidErrorsOccur = FALSE;

}

CTemplateInfo::~CTemplateInfo()
{
	delete m_pFormInformation, m_pDataFile, m_pTemplateName,
		 m_pSendTo, m_pRawData,m_pMailMsgBody,m_pMsgBody,m_pSucceed,m_pSubject,
		 m_pMailFrom,m_pRespondMsg,m_pRawFormData,m_pErrTemplate,m_pSMTPServer,
		 m_pDefaultSender,m_pDataFile;
}

void CTemplateInfo::SetTemplateFile(char* t, char* path)
{
	
	char* unix2dos;
	
	//In the unsightly event they use the unix path specifier, change to dos.
	while ( (unix2dos = strstr(t, "/")) != NULL)
		*unix2dos = '\\';
	m_pTemplateName = t;
	if (!LoadTemplateFile())
		//product error because we could not load/find the file
		HdrErr("Error loading template file", "Error occured loading the template file.  Please contact your system administrator");

}

////////////////////////////////////////////////////////////////////////////////
//Load the template file and dumps all the data into m_pRawData//
////////////////////////////////////////////////////////////////////////////////
int CTemplateInfo::LoadTemplateFile()
{
	FILE* pFile;
	char temptext[501] = "";
	int filesize;
	//Check to make sure the file exist, if not then error out, otherwise read the data
	if((pFile = fopen(m_pTemplateName, "rt")) != NULL)
	{
		//Determine the size of the file
		if ( (filesize = _filelength(_fileno(pFile))) == -1)
			return FALSE;

		//initialize m_pRawData
		m_pRawData = new char[filesize + 1];
		//Get all information from template file until we have reached the end (NULL)
		//We are only allowing 500 characters per line.
		_read(_fileno(pFile), m_pRawData, filesize);
		fclose(pFile);
		return TRUE;
	}
	else
		return FALSE;
}

///////////////////////////////////////////////////////////////////////////////

int CTemplateInfo::ParseTags()
{
	m_pDefaultSender = GetTagData("<SENDER>", "</SENDER>", TRUE);         //SENDER OF FORM
	m_pSMTPServer = GetTagData("<SMTPSERVER>", "</SMTPSERVER>", TRUE);    //MAIL SERVER
	m_pErrTemplate = GetTagData("<ERRTEMPLATE>", "</ERRTEMPLATE>", TRUE); //HTML TEMPLATE FOR FORM INPUT ERRORS
	m_pSubject = GetTagData("<SUBJECT>", "</SUBJECT>", TRUE);			  //SENDTO SUJECT LINE
	m_pRSubject = GetTagData("<RSUBJECT>", "</RSUBJECT>", FALSE);		  //RESPONDTO SUBJECT LINE
	m_pSucceed = GetTagData("<SUCCEEDMSG>", "</SUCCEEDMSG>", TRUE);		  //SUCCESS HTML PAGE
	m_pMsgBody = GetTagData("<MSGBODY>", "</MSGBODY>", TRUE);			  //SENDTO MESSAGE BODY
	m_pRespondMsg = GetTagData("<RMSGBODY>", "</RMSGBODY>", FALSE);		  //RESPONDTO MESSAGE BODY
	m_pDataFile = GetTagData("<DFILE>", "</DFILE>", FALSE);			      //DATAFILE NAME
	if (m_pDataFile != NULL)
		m_pDFileFormat = GetTagData("<DFILEFORMAT>", "</DFILEFORMAT>", FALSE);//DATAFILE FILE TEMPLATE
	ParseFormData();
	
	//We are finished with the template data, so let's free up some memory
	m_pRawData = NULL;

	return FALSE;
}

///////////////////////////////////////////////////////////////////////////////


/**********************************************************************
** GetTagData - Send it the tag you are looking for and it returns  ***
**				the data between the tag							***
**********************************************************************/
char* CTemplateInfo::GetTagData(char* BeginTag, char* EndTag, int required)
{
	char* pTagStart,
		* pTagEnd,
		* token = NULL;
	int tokenlength = 0,
		tokendifference = 0;
	char errstr[200];
	
	//Check to make sure the tags are there
	if ( stristr(m_pRawData, BeginTag) == NULL )
		if (required)
		{
			BeginTag += 1;
			strncpy(BeginTag + strlen(BeginTag) - 2, "\0", 1);
			sprintf(errstr, "&lt;%s&gt; is missing, please recheck your template file", BeginTag);
			HdrErr("Tag missing", errstr);
		}
		else
			return NULL;
	if ( stristr(m_pRawData, EndTag) == NULL )
		if (required)
		{
			EndTag += 1;
			strncpy(EndTag + strlen(EndTag) - 2, "\0", 1);
			sprintf(errstr, "&lt;%s&gt; is missing, please recheck your template file", EndTag);
			HdrErr("Tag missing", errstr);
		}
		else
			return NULL;
	
	//Parse out the data between the tags
	pTagStart = stristr(m_pRawData, BeginTag);
	pTagStart += strlen(BeginTag); //Move to the end ot the tag name
	
	pTagEnd = stristr(m_pRawData, EndTag);
	
	tokendifference =  strlen(pTagStart) - strlen(pTagEnd);
	token = new char[tokendifference + 2];

	strncpy(token, pTagStart, tokendifference);
	strncpy(token + tokendifference, "\0", 1);
	return token;

}
/////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
void CTemplateInfo::ParseFormData()
{
	m_pRawFormData = GetTagData("<FORMDATA>", "</FORMDATA>", TRUE);	
	SeperateFormTemplate(m_pRawFormData);
	GetFormData();	
	//DoComputations();
}

////////////////////////////////////////////////////////////////////////////////////
//Based upon the information gathered from the template file, Find the values     //
//stored in pCursor->pName and put the form variable contents into pCursor->pValue//
////////////////////////////////////////////////////////////////////////////////////
void CTemplateInfo::GetFormData()
{
	FormContents* pCursor = m_pFormInformation;
	do
	{
		//Based on the variable name, put the value in pCursor->pValue
		//Initialize pCursor->pValue
		
		pCursor->pValue = cgiData.FindData(pCursor->pName, FALSE);
		
		//Check to make sure that if it's a required field that it has some data in it.
		pCursor->IsFieldEmpty = FALSE;  //Let's start it at false.  This is for the required tag
		pCursor->IsInvalidType = FALSE; //Let's start at false.  This is for the type tag.
		
		DoRequiredChecking(pCursor);
		DoTypeChecking(pCursor);
		
		//Advance to the next variable link
		pCursor = pCursor->next;
	} while (pCursor != NULL);
	if (m_DidErrorsOccur)
		PrintErrHTML(m_pErrTemplate);
}

//////////////////////////////////////////////////////////////////////////////////
//Checks to see if the field is required (pCursor->required).  If it is required//
//and the value extracted from the form is empty, then mark as an error.		//
//////////////////////////////////////////////////////////////////////////////////
void CTemplateInfo::DoRequiredChecking(FormContents* pCursor)
{
	//Check to see if a field is required
	if (pCursor->required) 
	{
		if (!pCursor->pValue)
		{
			pCursor->IsFieldEmpty = TRUE;
			m_DidErrorsOccur = TRUE;
		}
		else			
		if ( strlen(pCursor->pValue) == 0) 
		{
			pCursor->IsFieldEmpty = TRUE;
			m_DidErrorsOccur = TRUE;
		}
	}
}

//////////////////////////////////////////////////////////////////////////////////
//Checks the fields to make sure they conform to the appropriate type.			//
//////////////////////////////////////////////////////////////////////////////////
void CTemplateInfo::DoTypeChecking(FormContents* pCursor)
{
	char* tempValue = NULL;
	//Do type checking only if there is any data to check
	if (!pCursor->IsFieldEmpty)
	{
		///////////////////////////////////////////////////////////////
		//Check to see if value is of the correct 'type'			  /
		///////////////////////////////////////////////////////////////
		//Check to see if it can be successfully converted to a number
		if (pCursor->VarType == TYPE_INT)
		{
			//Check each character and make sure it's between '(' and '9'.  If field
			//is empty, then skip type checking.  Let required handle the empty fields.
			tempValue = pCursor->pValue;
			while (*tempValue != '\0')
			{
				if ( (*tempValue < '(') || (*tempValue > '9') )
				{
					pCursor->IsInvalidType = TRUE;
					m_DidErrorsOccur = TRUE;
				}
				tempValue++;
			}
		}
		//For email, check to make sure it has at least an '@' sign and at least one
		//period.
		if (pCursor->VarType == TYPE_EMAIL)
		{
			if ( !strstr(pCursor->pValue, "@") || !strstr(pCursor->pValue, "."))
			{
				pCursor->IsInvalidType = TRUE;
				m_DidErrorsOccur = TRUE;
			}
		}
	}
	
}


////////////////////////////////////////////////////////////////////////////////////////////
//Based upon the infomation from the Template file, parse out the information in the      //
// <formdata>...</formdata> tags and store the informatin in pCursor->					  //
////////////////////////////////////////////////////////////////////////////////////////////
void CTemplateInfo::SeperateFormTemplate(char RawData[])
{
	char* token,
		*temptoken;
	char list_of_tokens[100][500];
	FormContents* pCursor = m_pFormInformation;
    char temp[500];
	int quoted_text = 0;
	int i = 0,
		j = 0;

	//Parse the form name information
 	token = strtok(RawData, "<");
	token = strtok(NULL, ">");
	do
	{
		//initialize variables
		pCursor->pName = pCursor->pOutput = pCursor->pReqErr 
					   = pCursor->pRespondMsg = pCursor->pValue
					   = pCursor->pTypeErr = NULL;
		pCursor->next = NULL;		
		pCursor->required = pCursor->replyto = pCursor->sendto = pCursor->respondto = FALSE;
		temptoken = token;
		//Set to default to type char unless changed below
		pCursor->VarType = TYPE_CHAR;

		while (*temptoken != '\0')
		{
			while ( (*temptoken != '\n' && *temptoken != ' ' && *temptoken != '\0') || 
				    (quoted_text != 0 && quoted_text < 2 && *temptoken != '\0' && *temptoken != '\n') )
			{
				temp[j] = *temptoken++;
				if (temp[j] == '\"')
					quoted_text++;
				j++;
			}
			
			temp[j] = '\0';
			if (j > 1)
			{
				if (quoted_text == 0)
					strcpy(list_of_tokens[i], temp);
				else if (quoted_text < 2)
				{
					sprintf(temp, "A closing quotation mark was missing from the below line.\n<br><pre>&lt;%s&gt;</pre>", token);
					HdrErr("Template Error", temp);

				}
				else if (quoted_text == 2)
					strcpy(list_of_tokens[i], temp);
				else if ( strstr(temp, "=") && quoted_text < 2)
					HdrErr("Template Error", "No quotes around text.  Please check your template file for errors");
				i++; 
			}
			j = 0; 
			quoted_text = 0;
			if (*temptoken != '\0')
				temptoken++;
		}
		for (j = 0; j < i; j++)				
		{
			GetSendToToken(list_of_tokens[j], pCursor);
			GetReplyToToken(list_of_tokens[j], pCursor);
			GetRespondToToken(list_of_tokens[j], pCursor);
			GetNameToken(list_of_tokens[j], pCursor);
			GetRequiredToken(list_of_tokens[j], pCursor);
			GetRequiredErrToken(list_of_tokens[j], pCursor);
			GetTypeToken(list_of_tokens[j], pCursor);
			GetTypeErrToken(list_of_tokens[j], pCursor);
		}
		j = i = 0;

		//Go to the next variable, if exists.
		token = strtok(NULL, "<");
		token = strtok(NULL, ">");
		if (token != NULL)
		{
			pCursor->next = new FormContents;
			pCursor = pCursor->next;
		}
		//If we haven't reached the end, then create a new leaf for the next group of data
	}while (token != NULL);
}

/////////////////////////////////////////////////////////////////////////////////
//Parse out the NAME= token and the associated value goes into pCursor->pName. //
//The variable pCursor->pName is the name of the form variable				   //
/////////////////////////////////////////////////////////////////////////////////
void CTemplateInfo::GetNameToken(char* token, FormContents* pCursor)
{
	char* nameToken = NULL,
		  err[100];;
	int stringsize = 0;
	
	nameToken = stristr(token, "NAME=");
	//Make sure the 'name' tag exists
	if (nameToken)
	{
		if ( (nameToken = stristr(token, "NAME=\"")))
		{
			//get the data between the double-quotes
			nameToken += 5;
			stringsize = strlen(++nameToken) - strlen (strstr(nameToken, "\""));
			
			pCursor->pName = new char[stringsize + 3];
			strncpy(pCursor->pName, nameToken, stringsize);
			strncpy(pCursor->pName + stringsize, "=\0", 2);
		}
		else
		{
				sprintf(err, "Error identifying the name line.  Please check your template file\n<br><pre>%s</pre>", token);
				HdrErr("Template Error", err);
		}
	}


}

/////////////////////////////////////////////////////////////////////////////////
//Parse out the 'required' token.  If exists, also get 'requiredErr' token	   //
/////////////////////////////////////////////////////////////////////////////////
void CTemplateInfo::GetRequiredToken(char token[], FormContents* pCursor)
{
	
	//Parse the required boolean information.  If the 'required' is there, then 
	//also get 'requiredErr' variable
	if (!stricmp(token, "required"))
		pCursor->required = TRUE;

}

void CTemplateInfo::GetRequiredErrToken(char token[], FormContents* pCursor)
{
	char* requiredErrToken = NULL,
		  err[100];
	int stringsize = 0;

	//Make sure the field 'requiredErr' exists.  If so, get the error message
	requiredErrToken = stristr(token, "REQUIREDERR=");
	if (requiredErrToken)
	{
		if (requiredErrToken = (stristr(token, "\"")))
		{
			stringsize = strlen(++requiredErrToken) - strlen (strstr(requiredErrToken, "\""));
			if (stristr(token, "<") != NULL)
			{
				sprintf(err, "Error on %s.  HTML tags are not allowed.  Use &lt;errTemplate&gt; tag below to customize your errors.", pCursor->pName);
				HdrErr("Error in template file", err);
			}
			pCursor->pReqErr = new char[stringsize + 2];
			strncpy(pCursor->pReqErr, requiredErrToken, stringsize);
			strncpy(pCursor->pReqErr + stringsize, "\0", 1);
		}
		else
		{
			sprintf(err, "Error identifying requiredErr line.  Please check your template file\n<br><pre>%s</pre>", token);
			HdrErr("Template Error", err);
		}
	
	}
	
	//The user specified 'required', but forgot to define a custom error message,
	// so let's create a default message.  Not pretty, but it works.
}

void CTemplateInfo::GetTypeToken(char token[], FormContents* pCursor)
{
	char* TypeToken;

	//Do rest if 'type' is found, otherwise we will leave at default 'char'.  Above.
	if ( (TypeToken = stristr(token, "TYPE=\""))!= NULL)
	{
		TypeToken += 5;
		//Check for different types other than the default type_char
		if (!_stricmp(TypeToken, "\"INT\""))
			pCursor->VarType = TYPE_INT;

		if (!_stricmp(TypeToken, "\"EMAIL\""))
			pCursor->VarType = TYPE_EMAIL;
	}
}

void CTemplateInfo::GetTypeErrToken(char token[], FormContents* pCursor)
{
	int stringsize = 0;
	char* typeErrToken,
	      err[200] = "";

	//Make sure the field 'typeErr' exists.  If so, get the error message
	typeErrToken = stristr(token, "TYPEERR=");
	if (typeErrToken)
	{
		if ( (typeErrToken = strstr(typeErrToken, "\"")) != NULL)
		{
			stringsize = strlen(++typeErrToken);

			//Just a little syntax checking for TypeErr to make sure that there are no html tags
			//In the error response.
			if (stristr(token, "<") != NULL)
			{
				sprintf(err, "Error on %s.  HTML tags are not allowed.  Use &lt;errTemplate&gt; tag below to customize your errors.", pCursor->pName);
				HdrErr("Error in template file", err);
			}
			pCursor->pTypeErr = new char[stringsize + 2];
			strncpy(pCursor->pTypeErr, typeErrToken, stringsize);
			strncpy(pCursor->pTypeErr + stringsize - 1, "\0", 1);
		}
		else
		{
			sprintf(err, "Error identifying typeErr line.  Please check your template file\n<br><pre>%s</pre>", token);
			HdrErr("Template Error", err);
		}
	}
}
/////////////////////////////////////////////////////////////////////////////////
//Get the 'sendto' token information										   //
/////////////////////////////////////////////////////////////////////////////////
void CTemplateInfo::GetSendToToken(char token[], FormContents* pCursor)
{
	//Parse 'sendto' boolean information.  This if statement checks to make sure that SENDTO is relatively
	//alone

	if (!stricmp(token, "sendto") )
		pCursor->sendto = TRUE;
}

/////////////////////////////////////////////////////////////////////////////////
//Get the 'sendto' token information										   //
/////////////////////////////////////////////////////////////////////////////////
void CTemplateInfo::GetReplyToToken(char token[], FormContents* pCursor)
{
	//Parse 'sendto' boolean information.  This if statement checks to make sure that SENDTO is relatively
	//alone

	if (!stricmp(token, "replyto")) 
		pCursor->replyto = TRUE;
}

/////////////////////////////////////////////////////////////////////////////////
void CTemplateInfo::GetRespondToToken(char token[], FormContents* pCursor)
{
	char* respondToken = NULL;
	int stringsize = 0;
	char err[100] = "";

	//Parse 'respondto' boolean information'
	if (!stricmp(token, "respondto")) 
	{
		//respondto and sendto cannot co-exist
		if (pCursor->sendto)
			HdrErr("Bad command in template file", "If there is a &lt;sendto&gt; tag, then there cannot be a &lt;respondto&gt; tag");

		pCursor->respondto = TRUE;
	}
}

///////////////////////////////////////////////////////////////////////////////
//Get the mail subject line													 //
/////////////////////////////////////////////////////////////////////////////////
int CTemplateInfo::ParseSubject()
{
	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////////
//All the data that's stored in the link list (pCursor), dump all it's contents//
//into a single variable that will, later, be dumped out to a file			   //
/////////////////////////////////////////////////////////////////////////////////
void CTemplateInfo::GenerateMailToFile()
{
	FormContents* pCursor = m_pFormInformation;
	DWORD msgbodysize = strlen(m_pMsgBody);
	//Determine how large to make the array of the message body
	while (pCursor != NULL)
	{
		if (pCursor->pValue != NULL)
			msgbodysize += strlen(pCursor->pValue);
		pCursor = pCursor->next;
	}

	char* tempstr = new char[msgbodysize];
	char* msgbody;
	char* tempstart = tempstr;

	msgbody = ReplaceWithFormValues(m_pMsgBody, "SENDTO");
	
    //At each point where there is a <cr>, replace with <cr><lf>
	for (int i = 0; i <= (int)strlen(msgbody); i++)
	{
		if (msgbody[i] == '\n')
		{
			//This section checks to see if there is a period on it's own line.  If there is
			//then add and additional period.  End result will look like "..".  That way when the
			//mail server gets it, it won't see it as the end of "DATA" and terminate.  See rfc821 for
			//details about periods on there own line.
			if ( (msgbody[i + 1] == '.') && (msgbody[i + 2] == '\n') )
			{
				*tempstr++ = '\r'; *tempstr++ = '\n'; *tempstr++ = '.'; *tempstr++ = '.'; 
				*tempstr++ = '\r'; *tempstr++ = '\n';
				i += 2;
			}
			else
			{
				*tempstr++ = '\r';
				*tempstr++ = '\n';
			}
		}
		else 			
			*tempstr++ = msgbody[i];
	}
	*tempstr = '\0';
	m_pMsgBody = tempstart;
	delete msgbody;
	//strcpy(m_pMailMsgBody, tempstart);
	//delete tempstart, tempstr;
}

/////////////////////////////////////////////////////////////////////////////////
//Mail all the information to all the 'sendto' tagged people and send out the  //
//'respondto' tag data to the respective people.  
/////////////////////////////////////////////////////////////////////////////////
void CTemplateInfo::MailInformation(char* filepath)
{
	char buf[MAX_MSGBODY_SIZE + MAX_EMAIL_HEADER_SIZE];
	FormContents* pCursor = m_pFormInformation;
	char* pRespondMsgBody;
	char pbodyto[MAX_EMAIL_HEADER_SIZE] = "";
	char pReplyTo[MAX_EMAIL_HEADER_SIZE] = "";
	CISock c1;
	char temp[600] = "";
	char psocketerrors[2000] = "";
    //Error message in the event we cannot connect to the mail server
	sprintf(temp, "An error occured while establishing a socket"
			      "connection.<br>\nPossible reasons include <ul>\n"  
				  "<li>A usable winsock.dll could not be found.\n"
				  "<li>Your winsock.dll does not support 1.1 (It should unless you are using a very old version.\n"
				  "<li>Program could not resolve your hostname\n"
				  "<li>Could not connet to the mail server (most likely problem)\n"
				  "<li>Your settings in the &lt;SMTPSERVER&gt; tag is incorrect\n"
				  "</ul>");
	
	//Create the body of the message
	GenerateMailToFile();

	//Initialize the socket
	if (c1.InitializeSocket(m_pSMTPServer) == SOCKET_ERROR)
		HdrErr("Socket Error", temp);
	c1.ReceiveData(psocketerrors);

	//Mail information to the primary recipient(s)
	//The CISock class is completely seperate from specific details of the SMTP mail protocol.  That is
	//why all error handling is done here vs. in the class.  Makes it so I can use that class on another 
	//project without have to make specific modifications to the code
	//setup for SMTP HELLO
	sprintf(buf, "HELO %s\r\n", c1.m_pLocalHostName);
	c1.SendData(buf); 
	strcat(psocketerrors, buf);
	if (c1.ReceiveData(psocketerrors) != 250)
	{
		sprintf(temp, "Error occured while communicating with the mail server (SENDTO's HELO).  The mail server returned <p>%s<p> ", psocketerrors);
		HdrErr("Mail error occured", temp);
	}
	
	//Send MAIL FROM information to the smtp server.
	sprintf(buf, "MAIL FROM:<%s>\r\n", m_pDefaultSender);
	c1.SendData(buf);
	strcat(psocketerrors, buf);
	if (c1.ReceiveData(psocketerrors) != 250)
	{
		sprintf(temp, "Error occured while communicating with the mail server (SENDTO's MAIL FROM).  The mail server returned <p>%s.<p> ", psocketerrors);
		HdrErr("Mail error occured", temp);
	}
	//Generate sendto information.  In order to make sure we have someone to send some data to
	//If we don't, then the intent is to skip the sendto and go to the respondto
	strcpy(buf, "");
	do
	{
		if (pCursor->sendto)
		{
			sprintf(buf, "RCPT TO:<%s>\r\n", _strlwr(pCursor->pValue));
			sprintf(pbodyto, "%s %s,", pbodyto, _strlwr(pCursor->pValue));
			strcat(psocketerrors, buf);
			c1.SendData(buf); c1.ReceiveData(psocketerrors);
		}
		pCursor = pCursor->next;
	} while (pCursor != NULL);		

	//Place a null terminator in place of the last comma
	pbodyto[strlen(pbodyto) - 1] = '\0';

	//Now generate the Reply-To information
	pCursor = m_pFormInformation;
	do
	{
		if (pCursor->replyto)
			sprintf(pReplyTo, "%s %s,", pReplyTo, _strlwr(pCursor->pValue));
		pCursor = pCursor->next;
	} while (pCursor != NULL);		

	m_pDefaultSender = ReplaceWithFormValues(m_pDefaultSender, "SENDER");
	
	pCursor = m_pFormInformation;
	//If 'sendto' is specified, then perform the sendto action
	if (strlen(pbodyto) != 0)
	{
		
		if (m_pSubject)
			m_pSubject = ReplaceWithFormValues(m_pSubject, "SUBJECT");

		
		//check to see if the header information is too large
		if (strlen(pbodyto) >= MAX_EMAIL_HEADER_SIZE)
			HdrErr("Mail error", "You have to many people you are sending your message to.  Please trim or e-mail the programmer and ask him to increase the size");

		strcat(psocketerrors, buf);
		c1.SendData("DATA\r\n");  
		strcat(psocketerrors, "DATA\r\n");
		c1.ReceiveData(psocketerrors);
		sprintf(buf, "From: %s\r\n"
					 "Sender: %s\r\n"
					 "Reply-To: %s \r\n"
					 "Subject: %s\r\n" 
					 "To: %s\r\n"
					 "X-Mailer: <NTMailer %s>\r\n"
					 "\r\n%s\r\n", m_pDefaultSender, m_pDefaultSender, pReplyTo, 
							       m_pSubject, pbodyto, VERSION, m_pMsgBody); 
		c1.SendData(buf);
		c1.SendData("\r\n.\r\n");   
		strcat(psocketerrors, "\r\n.\r\n");
		c1.ReceiveData(psocketerrors);

		//Now do the Mailback to person filling out form
		pCursor = m_pFormInformation;
	}	
	else //Reset the transaction, because we have nothing to send
	{
		c1.SendData("RSET"); 
		//c1.ReceiveData(psocketerrors);
	}

	//If the user didn't specify a respond message, then there is no point 
	//in running this section.
 	if (m_pRespondMsg != NULL)
	{
		pRespondMsgBody = ReplaceWithFormValues(m_pRespondMsg, "RESPONDTO");
		do
		{
			//If there is someone to respond to, then do it
			if (pCursor->respondto) 
			{
				if (m_pRSubject)
					m_pRSubject = ReplaceWithFormValues(m_pRSubject, "RSUBJECT");

				//reversed from and to so the original sender of the form gets a confirmation request.  This is
				//used to verify that the user sent the correct e-mail address.
				//setup for SMTP HELLO
				sprintf(buf, "MAIL FROM:<%s>\r\n", m_pDefaultSender);
				c1.SendData(buf);
				strcat(psocketerrors, buf);
				if (c1.ReceiveData(psocketerrors) != 250)
				{
					sprintf(temp, "Error occured while communicating with the mail server (RESPONDTO's MAIL FROM).  The mail server returned <p>%s<p>", psocketerrors);
					HdrErr("Mail error occured", temp);
				}
				sprintf(buf, "RCPT TO:<%s>\r\n", _strlwr(pCursor->pValue)); c1.SendData(buf); 
				strcat(psocketerrors, buf);
				c1.ReceiveData(psocketerrors);
				c1.SendData("DATA\r\n");  
				strcat(psocketerrors, "DATA\r\n");
				c1.ReceiveData(psocketerrors);

				sprintf(buf, "From: %s\r\n"
							 "Sender: %s\r\n"
							 "Subject: %s\r\n"
							 "To: %s\r\n"
							 "X-Mailer: <NTMailer %s>\r\n"
							 "\r\n%s\r\n", m_pDefaultSender, m_pDefaultSender,
									       m_pRSubject, _strlwr(pCursor->pValue), VERSION,
									       pRespondMsgBody); 
				c1.SendData(buf); 
				c1.SendData("\r\n.\r\n");   
				strcat(psocketerrors, "\r\n.\r\n");
				c1.ReceiveData(psocketerrors);
			}
			pCursor = pCursor->next;

		} while(pCursor != NULL);
	}
	c1.SendData("QUIT\r\n");   
	strcat(psocketerrors, "QUIT\r\n");
	c1.ReceiveData(psocketerrors);

	if (m_pDataFile != NULL)
		RecordFormToFile(filepath);
	
	if (MAIL_DEBUG == TRUE)
		HdrErr("rfc821 mail transaction process", psocketerrors);
	PrintSucceedMsg();
}

/////////////////////////////////////////////////////////////////////////////////
//This is the HTML Success message. Replace anything with $..$ around them
//with the actual value of the variable specified.
/////////////////////////////////////////////////////////////////////////////////
void CTemplateInfo::PrintSucceedMsg()
{
	//FormContents* pCursor = m_pFormInformation;
	
	PrintHeader(NULL);

	printf(ReplaceWithFormValues(m_pSucceed, "SUCCEEDMSG"));
}

char* CreateTempFile(const char* pFileContents)
{
	FILE* pOutputFile;			//File stream that data is written to
	char* pTempFileName = NULL;

	//Create a temporary file to contain the information to send through blat
	//GetTempPath( sizeof(pTempDir), pTempDir );
    
	pTempFileName = new char[15];
	GetTempFileName( ".\\", "cml", 0, pTempFileName );

	if ( (pOutputFile = fopen(pTempFileName,"w") ) == NULL)
	{
		//Couldn't file the file
		HdrErr("File Creation error", "Error occured while creating mail file.");
		exit(0);
	}	
	fputs ("\n", pOutputFile);
	fputs (pFileContents, pOutputFile);
	fputs ("\n", pOutputFile);
	fclose(pOutputFile);

	return pTempFileName;
}

void CTemplateInfo::PrintErrHTML(char* errstring)
{
	char temp[MAX_MSGBODY_SIZE] = "";
	char* errtag = NULL;
	FormContents* pCursor = m_pFormInformation;
	
	int j = 0;

	errtag = stristr(m_pErrTemplate, "$err$");
	//If $err$ is not specified, then skip the below section and go right into ReplaceWithFormValues
	if (errtag != NULL)
	{
		//Print up to the $err$ label
		for (char* i= m_pErrTemplate; i < errtag; i++)
		{
			sprintf(temp, "%s%c", temp, *i);
		}
		//move past the size of $err$
		errtag += 5;
		//process errstring
		while (pCursor != NULL)	
		{
			//Error section for required fields
			if (pCursor->IsFieldEmpty)
			{
				if ( (strlen(temp) + strlen(pCursor->pReqErr)) < MAX_MSGBODY_SIZE)
					sprintf(temp, "%s<li>%s", temp, pCursor->pReqErr);
				else
					HdrErr("Mail send error", "Maximum size reached on &lt;errTemplate&gt;.  Please trim it down");
			}
			//Error section for invalid types
			if (pCursor->IsInvalidType)
			{
				if ( (strlen(temp) + strlen(pCursor->pTypeErr)) < MAX_MSGBODY_SIZE)
					sprintf(temp, "%s<li>%s", temp, pCursor->pTypeErr);
				else
					HdrErr("Mail send error", "Maximum size reached on &lt;errTemplate&gt;.  Please trim it down");
			}
			pCursor = pCursor->next;
		}
		if ( (strlen(temp) + strlen(errtag)) < MAX_MSGBODY_SIZE)
			strcat(temp, errtag);
		else
			HdrErr("Mail send error", "Maximum size reached on &lt;errTemplate&gt;.  Please trim it down");
	}
	//Replace form tags and print
	HdrErr(NULL, ReplaceWithFormValues(temp, "FORMERRORS"));

	exit(0);
}

int CTemplateInfo::RecordFormToFile(char* filepath)
{
	FILE * pFile;
	FormContents* pCursor = m_pFormInformation;
	char NULLREPLACEMENT[3] = " \0";
	char datetime[11] = "";

	char* unix2dos;
	//GetDateFormat(NULL, DATE_SHORTDATE, NULL, "dd/MM/yyyy", datetime, 11);

	//Check to make sure that the person has a <dfileformat> specified.  If not, error out.
	if (m_pDFileFormat == NULL)
		HdrErr("Error writing to file", "A &lt;dfileformat&gt; was not specified.");

	//In the unsightly event they use the unix path specifier, change to dos.
	while ( (unix2dos = strstr(m_pDataFile, "/")) != NULL)
		*unix2dos = '\\';
	if((pFile = fopen(m_pDataFile, "a+t")) != NULL)
	{
		fprintf(pFile, ReplaceWithFormValues(m_pDFileFormat, "FORMTOFILE"));
		//fprintf(pFile, "%s", datetime);
		fprintf(pFile, "\n");
		fclose(pFile);

	}
	else 
		//Failed to open the file
		return FALSE;
	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////////
//Any homeless variables will be ignored.

char* CTemplateInfo::ReplaceWithFormValues(char* ptempstring, const char* IdentifiedProcess)
{
	FormContents* pCursor = m_pFormInformation;
	//DWORD msgbodysize = strlen(ptempstring);
	char* token,
	    * msgbody = new char[MAX_MSGBODY_SIZE],
	    * pEnvVar = NULL,
	    * ptemp = new char[strlen(ptempstring) + 1],
	      systemdate[10] = "",
		  systemtime[10] = "",
		  dupstring[100];
	int sizecounter = 0,
	    SPACE_ENTERED = FALSE;

	//set systemdate and systemtime
	_strdate(systemdate);  
	_strtime(systemtime);
	
	strcpy(msgbody, "");
	strcpy(ptemp, " ");

	pCursor = m_pFormInformation;

	if (*ptempstring == '$')
	{
		SPACE_ENTERED = TRUE;
		strcat(ptemp, ptempstring);
	}
	else
		strcpy(ptemp, ptempstring);

	token = strtok(ptemp, "$");
	
	//This if statement was designed because I had a problem with the first character being a $.
	//If it was a dollar sign, then the whole process would mess up. This is part 1 of the fix.
	if (*ptemp != '$') 
		sprintf(msgbody, "%s", token);

	if (token != NULL) 
	{
		//This second check to the above statement was part 2 of the fix.	
		if (*ptemp != '$')
		{
			//If person enters a $$, then that means they want to use a literal dollar sign ($)
			if (!strcmp(token + 1, "$"))
			{
				sizecounter++;
				sprintf(msgbody, "%s$", msgbody);
			}
			token = strtok(NULL, "$");
		}
		while (token != NULL)
		{
			while (pCursor != NULL)
			{
			//Have we stumbled across a form variable?
				//I know this looks funny, but what this says is to duplicate token (as to preserve
				//the original token variable) add an equal sign (=) and then compare to pCursor->pName
				//for a match.
				//All pNames have an = sign on the end.
				
				strcpy(dupstring, token);
				if (!stricmp(strcat(dupstring, "=\0"), pCursor->pName) )
				{
					if (pCursor->pValue) //Check to make sure it's not null.  If it is, then the app will die on the strlen.
					{
						//Check to make sure we will not exceed the region
						if ( (sizecounter += strlen(pCursor->pValue)) < MAX_MSGBODY_SIZE)
						{
							sprintf(msgbody, "%s%s", msgbody, pCursor->pValue);
							pCursor = NULL;
						}
						else
							HdrErr("Mail send error", "Your message body is over 15k (15360 bytes).  Please trim down in &lt;msgbody&gt; and/or &lt;rmsgbody&gt; in your template file");
					}
					else
						// This will happen if for some reason pCursor->pValue is NULL
						pCursor = pCursor->next;
				}
				else 
				{
					//Let's see if it's our reserved $systemtime$ variable
					if (!strcmp(token, "systemtime"))
					{
						//Check to make sure we will not exceed max
						if ( (sizecounter += strlen(systemtime)) < MAX_MSGBODY_SIZE)
						{
							sprintf(msgbody, "%s%s", msgbody, systemtime);
							pCursor = NULL;
						}
					}
					//Let's see if it's our reserved $systemdate$ variable
					else if (!strcmp(token, "systemdate"))
					{
						//Check to make sure we will not exceed max
						if ( (sizecounter += strlen(systemtime)) < MAX_MSGBODY_SIZE)
						{
							sprintf(msgbody, "%s%s", msgbody, systemdate);
							pCursor = NULL;
						}
					}
					// let's see if it's an environment variable
					//If getenv returns NULL, then we know it's not a valid env var.
					else if ( (pEnvVar = getenv(_strupr(token))) != NULL)
					{
						//Check to make sure we will not exceed max
						if ( (sizecounter += strlen(pEnvVar)) < MAX_MSGBODY_SIZE)
						{	
							sprintf(msgbody, "%s%s", msgbody, pEnvVar);
							pCursor = NULL;
						}
					}	
					else
						pCursor = pCursor->next;
				}
			}
			pCursor = m_pFormInformation;
			token = strtok(NULL, "$");
			//If we have reached the end, then skip the next section, otherwise the program will
			//bomb on the strlen of token.
			if (token != NULL)
			{
				//Check to make sure we will not exceed the 15k region
				if ( (sizecounter += strlen(token)) < MAX_MSGBODY_SIZE)
					sprintf(msgbody, "%s%s", msgbody, token);
				else
					HdrErr("Mail send error", "Your message body is over 15k (15360 bytes).  Please trim down in &lt;msgbody&gt; and/or &lt;rmsgbody&gt; in your template file");

				//If person enters a $$, then that means they want to use a $
				if (!strcmp(token + 1, "$"))
					//Check to make sure we will not exceed the region
					if ( (sizecounter++) < MAX_MSGBODY_SIZE)
						sprintf(msgbody, "%s$", msgbody);
					else
						HdrErr("Mail send error", "Your message body is over 15k (15360 bytes).  Please trim down in &lt;msgbody&gt; and/or &lt;rmsgbody&gt; in your template file");
			}
			token = strtok(NULL, "$");
		}
	} 
	return msgbody;
}





