#include <stdio.h>
#include <iostream.h>
#include <string.h>
#include <process.h>
#include <conio.h>
#include <stdlib.h>
#include <ctype.h>
#include <windows.h>

#include "cgi.h"

CCGI::CCGI()
{
}

CCGI::~CCGI()
{
	delete m_method,
	       m_name;
}

/////////////////////////////////////////////////////////////////////////////////
//This is primarily for debugging purposes.  Allows a developer to manually set//
//the form data.															   //
/////////////////////////////////////////////////////////////////////////////////
void CCGI::SetContent(char* content)
{
	if (content)
	{
		m_content = new char[strlen(content) + 2];
		m_ContentLength = strlen(m_content);
		strcpy(m_content, content);
		strncpy(m_content + strlen(content), "&\0", 2);
	}
}


/////////////////////////////////////////////////////////////////////////////////
//Gets the values from the form
/////////////////////////////////////////////////////////////////////////////////
BOOL CCGI::Initialize(const char* method_type)
{
	char* clstr;
	int content_length;

	
	m_method = getenv("REQUEST_METHOD");
	//Do a quick check of the above to make sure we are getting environment
	//variables correctly.  If it fails, then the person is probably running
	//this program from the command-line prompt vs. a cgi program.
	if (m_method == NULL)
	{
		printf("Error occured while collecting some environment variables.\n"
			   "Chances are you are trying to run this program from the\n"
			   "command line prompt.  It must be run as part of a cgi call\n"
			   "from the web server.");
		exit(0);
	}
	
	//Check the Method 
	if (strcmp(m_method, method_type) != 0)  
		HdrErr("Form Submit Error", "You must submit a form with a POST method.");
	
	//Check to make sure the browser supports this function
	clstr = getenv("CONTENT_LENGTH");
	if(!clstr)
		HdrErr("No data", "Your browser didn't send any content.  Is it not POST capable?");
	
	//convert the CONTENT_LENGTH string into an integer
	content_length = atoi(clstr);
	m_content = new char[content_length + 2];
	
	m_ContentLength = content_length + 2;

	/*
	 * Check for netgative or outrageously large content lengths
	 * An upper limit is set to make sure they don't steal extra system
	 * resources for no good reason
	 */
	
	if ( content_length < 0 )
		HdrErr("No data", "Your browser did not send any data from the form");
		
	fread(m_content, 1, content_length, stdin);

	//Add an additional '&' at the end so the strtok will work correctly in FindData(...)

	m_content[content_length] = '&';
	m_content[content_length + 1] = '\0';
	m_content = url_decode(m_content);
	
	return FALSE;
}

BOOL CCGI::ParamExist(char param_to_find[])
{
	if ( stristr(m_content, param_to_find) != NULL )
		return TRUE;
	return FALSE;
}

//////////////////////////////////////////////////////////////////////////////////
//Given 'form_variable' will return the contents of the variable.  If it doesn't//
//exist, then it sends out an HTML err stating that the variable does not exist //
//////////////////////////////////////////////////////////////////////////////////
char* CCGI::FindData(const char* form_variable, BOOL REQUIRED)
{
	char* strresult = NULL;
	char* token;
	char buf[1000];
	int stringlength;
	//Parse the form_variable from the whole string(m_content).  Should now be in the 
	//format of form_variable=value&form_variable=value&
	
	//find the form_variable requested 
	if (m_content)
	{
		char* TempContent = new char[m_ContentLength];
		strresult = stristr(m_content, form_variable); 
		if (strresult == NULL)
			if (!REQUIRED)
				return NULL;
			else
			{
				sprintf(buf, "Form name couldn't be found: %s.\n<br>\nHere is my POST information\n<br>%s", form_variable, m_content);
				HdrErr("Form Information Missing", buf);
			}
		stringlength = strstr(strresult, "&") - strresult;
		token = new char[stringlength + 1];

		strncpy(token, strresult, stringlength);
		strncpy(token+stringlength, "\0", 1);
		token = strstr(token, "=");
		++token;
		
		
		//Advance the pointer by one to get pasted the '='

		return token;
	}
	return NULL;
}

int CCGI::is_hex(char hex)
{
	//*****Taken from the Netscape handbook.  ********
	
	//Make sure it's upper case
	if (isalpha(hex))
		hex = toupper(hex);

	//This just checks the character to see if it's in the two ranges
	if(((hex < 'A') && (hex > 'F')) && ((hex < '0') && (hex > '9')))
		return 0;
	else 
		return 1;
}

char* CCGI::url_decode(char* token)
{
	//*****Taken from the Netscape handbook.  ********

	//Decodes any special characters.
	//Allocate space for the new string.  We won't need more space than we 
	//already have after decoding
	int stringlength = strlen(token);
	char *string = new char[stringlength + 1];
	//char *string = (char *) malloc((strlen(token) + 1) * sizeof(char));
	//Index register fo string copy
	char* enc, *dec;
	//Digit is used to translate hex into character
	char digit;

	//We go through the string, looking for + signs or percents
	for (enc = token, dec = string; *enc; enc++, dec++)
	{
		if (*enc != '%')
		{
			//Plus goes to space
			if (*enc == '+')
			{
				*dec = ' ';
			}
			else 
				*dec = *enc;
		}
		else 
		{
			//Another tricky part.  First, make sure we got what we want
			if ((!is_hex(enc[1])) || (!is_hex(enc[2])))
				HdrErr("NTMailer error", "Invalid escape sequence");

			//Now, advance over the % sign to the first digit and decode
			//The oxdf is to turn the character into upper case
			//Modification made due to that fact that the one in the handbook didn't work.
			++enc;
			digit = 0;
			if (*enc >= 'A')
				digit = 16 * (((*enc & 0xdf) - 'A') + 10);
			else
				digit = 16*(*enc - '0');

			++enc;
			if (*enc >= 'A')
				digit += ((*enc & 0xdf) - 'A') + 10;
			else
				digit += *enc - '0';
			
			*dec = digit;
		}
	}
	*dec = '\0';
	return string;
}

/**Generic error handler.  Since this function does not PrintHeader, make sure you call PrintHeader
   before using this function, otherwise you will get a server error.  The error has to do with the
   fact that you didn't specify the Content-type
*/
void err(char errstr[])
{
	printf("%s\n", errstr);
	PrintTrailer(NULL);
	exit(0);
}

void PrintHeader(const char* title)
{
	// Two carriage returns (\n\n) are required by the html browser.  Do not remove it 
	//or you will get a web server error
	//This is if statement is to add additional header information for MIIS

	if ( stristr(getenv("SERVER_SOFTWARE"), "microsoft") != NULL)
		printf("HTTP/1.0 200 OK\n"
			   "Content-type: text/html\n\n\n");
	else
		printf("Content-type: text/html\n\n");

	printf("<HTML>\n");
	if (title != NULL)
		printf("<TITLE>%s</TITLE>", title);
	
}

//Place for any static trailer information
void PrintTrailer(const char* trailer)
{
	if (trailer != NULL)
		printf("%s", trailer);
	printf("\n</HTML>");
}

////////////////////////////////////////////////////////////////////////////////////
//This performs the same function that strstr does, but this is a case-insensitive//
//version.																		  //
////////////////////////////////////////////////////////////////////////////////////
char* stristr(char* source, const char* comparewith)
{
	char* t1,
		* t2,
		* t3;
	char* cw;
	
	t1 = _strdup(source);
	t2 = t1;
	t3 = source;
	cw = _strdup(comparewith);

	t2 = strstr(_strupr(t1), _strupr(cw));

	if (t2 == NULL)
		return NULL;
	
	t3 = source + (t2 - t1);
	
	delete t1, t2, cw;
	return t3;

}
void HdrErr(char* pErrorHeader, char* pErrorText)
{
	PrintHeader(pErrorHeader);
	printf(pErrorText);
	exit(0);
}
