struct FormContents {
	char* pName,
		* pOutput,
	    * pReqErr,
		* pRespondMsg,
		* pValue,
		* pTypeErr,
	    * pComputeErr,
	    * pCompute;
	int required,
		sendto ,
		respondto,
		replyto,
		IsFieldEmpty,
		VarType,
		IsInvalidType;
	FormContents* next;
};

struct HtmlVars
{
	char variable[33],
		 *value;

};

class CTemplateInfo
{
public:
	CTemplateInfo();
	~CTemplateInfo();
	void SetTemplateFile(char*, char* );
	int ParseTags();
	int ProcessFormInformation();
	void MailInformation(char*);

	//This is a debug mode so you can see the communication between the mail 
	//server and this program
	int MAIL_DEBUG;


protected:
	void GenerateMailToFile();
	void GetFormData();
	int LoadTemplateFile();
	void ParseFormData();
	void SeperateFormTemplate(char[]);
	int ParseOutput();
	int ParseSubject();
	char* GetTagData(char*, char*, int);
	void PrintSucceedMsg();

private:
	void DoRequiredChecking(FormContents* );
	void DoTypeChecking(FormContents* );
	char* m_pRSubject;
	void GetTypeToken(char [], FormContents* );
	char* m_pDFileFormat;
	int m_DidErrorsOccur;
	char* ReplaceWithFormValues(char*, const char*);
	int RecordFormToFile(char*);
	void PrintErrHTML(char*);
	void GetRespondToToken(char token[], FormContents* pCursor);
	void GetReplyToToken(char token[], FormContents* pCursor);
	void GetSendToToken(char token[], FormContents* pCursor);
	void GetRequiredToken(char token[], FormContents* pCursor);
	void GetNameToken(char* token, FormContents* pCursor);
	void GetRequiredErrToken(char token[], FormContents* pCursor);
	void GetTypeErrToken(char token[], FormContents* pCursor);

	
	HtmlVars m_TemplateVars[50];
	char* m_pTemplateName,
		* m_pSendTo,
		* m_pRawData,
		* m_pMailMsgBody,
	    * m_pMsgBody,
		* m_pSucceed,
		* m_pSubject, 
		* m_pMailFrom,
		* m_pRespondMsg,
		* m_pRawFormData,
		* m_pErrTemplate,
	    * m_pSMTPServer,
	    * m_pDefaultSender,
		* m_pDataFile;
	CCGI cgiData;
	FormContents* m_pFormInformation;
};

char* CreateTempFile(const char*);


